Unit MLU32_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure MLU32(var X :Array of Real; M :Integer;
                var XK :Array of Real; K :Integer; var L :Integer;
                var TETA :Real; var NX :Array of Integer; EPS :Real;
                var ALFA :Array of Real; KV :Integer; var NA :Integer;
                var NALFA :Array of Integer);

implementation

procedure MLU32(var X :Array of Real; M :Integer;
                var XK :Array of Real; K :Integer; var L :Integer;
                var TETA :Real; var NX :Array of Integer; EPS :Real;
                var ALFA :Array of Real; KV :Integer; var NA :Integer;
                var NALFA :Array of Integer);
var
M1,I,J,K1,K2,K3,K6 :Integer;
A,R :Real;
const
O16000 :Integer = 16000;
O10E10 :Real = 10E10;
SYS085 :Real = 1.0E-9;
label
_1,_2,_7,_6,_5,_4,_8,_3;
begin
{        OCK CTOA ,BBOMOO  }
{        ACA ,  AA C BEPHM }
{        OPAHEHM HA EPEMEHHE }
{        L - HOMEP BBO  }
NA := 0;
TETA := O10E10;
M1 := M-2;
A := -1.0;
for I:=1 to KV do
 begin
  K1 := NALFA[I-1];
  K2 := K1;
  if ( K1 > O16000 )
   then K2 := K1-O16000;
  if ( K2 = K )
   then goto _2;
_1:
 end;
goto _6;
_2:
A := ALFA[I-1];
TETA := A;
NA := I;
if ( K1 = K2 )
 then goto _6;
for I:=1 to M do
 begin
_7:
  XK[I-1] := -XK[I-1];
 end;
_6:
for I:=1 to M1 do
 begin
  if ( Abs(XK[I-1]) < EPS ) 
   then goto _3;
  if ( XK[I-1] < (-EPS) )
   then goto _4;
  R := X[I-1]/XK[I-1];
_5:
  if ( R >= TETA )
   then goto _3;
  TETA := R;
  L := I;
  goto _3;
_4:
  K3 := NX[I-1];
  for J:=1 to KV do
   begin
    K6 := NALFA[J-1];
    if ( K6 <> K3 )
     then goto _8;
    R := (X[I-1]-ALFA[J-1])/XK[I-1];
    goto _5;
_8:
   end;
_3:
 end;
if ( Abs(TETA-A) < SYS085 )
 then L := 0;
if ( A <> -1.0 ) and ( K1 <> K2 )
 then L := L+O16000;
end;

end.
